"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnumerationBuilder = void 0;
class EnumerationBuilder {
    constructor(enumerationClass) {
        this.enumerationClass = enumerationClass;
    }
    parse(value) {
        return this.all().find((instance) => instance.value === value);
    }
    all() {
        const properties = Object.keys(this.enumerationClass);
        return properties
            .map((name) => this.enumerationClass[name])
            .filter((value) => value instanceof this.enumerationClass);
    }
}
exports.EnumerationBuilder = EnumerationBuilder;
