import { AnyEntity, EntityBase, EntityBaseConstructorParamsWithProps, GetEntityProps } from '../../core/entity.base';
import { AbstractClass, Class } from 'type-fest';
import { AbstractableClass } from './abstractable-class';
export type EntityConstructorParamsWithProps<Props> = [
    ...(EntityBaseConstructorParamsWithProps<Props> extends [infer T, ...infer R] ? R : never)
];
export type EntityConstructorParams<T extends AnyEntity> = EntityConstructorParamsWithProps<GetEntityProps<T>>;
export type EntityStatic<C extends AbstractableClass<AnyEntity>> = C & {
    EntityType: string;
};
export type EntityClassWithProps<Props> = Class<EntityBase<Props>, EntityConstructorParamsWithProps<Props>>;
export type EntityClass<T extends AnyEntity> = Class<T, EntityConstructorParams<T>>;
export type AbstractEntityClassWithProps<Props> = AbstractClass<EntityBase<Props>, EntityConstructorParamsWithProps<Props>>;
export type AbstractEntityClass<T extends AnyEntity> = AbstractClass<T, EntityConstructorParams<T>>;
