import { AnyDomainEvent } from './domain-event.base';
import { EntityBase, GetEntityProps } from './entity.base';
export declare abstract class AggregateBase<P> extends EntityBase<P> {
    protected _originalVersion: number;
    protected _events: AnyDomainEvent[];
    protected _loaded: boolean;
    constructor(type: string, id: string, props: P, originalVersion: number, loaded: boolean);
    static isAggregate(obj: object): obj is AnyAggregate;
    hasUnpublishedEvents(): boolean;
    protected recordEvent(event: AnyDomainEvent): void;
    clearEvents(): void;
    isNew(): boolean;
    get events(): AnyDomainEvent[];
    get originalVersion(): number;
    get version(): number;
    get loaded(): boolean;
}
export type AnyAggregate = AggregateBase<any>;
export type AggregateBaseConstructorParamsWithProps<P> = ConstructorParameters<typeof AggregateBase<P>>;
export type AggregateBaseConstructorParams<T extends AnyAggregate> = AggregateBaseConstructorParamsWithProps<GetEntityProps<T>>;
