export interface DomainEventMetadata {
    eventType: string;
    aggregateType: string;
}
export declare class DomainEventBase<P> {
    readonly metadata: Readonly<DomainEventMetadata>;
    readonly id: string;
    readonly aggregateId: string;
    readonly timestamp: number;
    readonly props: Readonly<P>;
    constructor(metadata: DomainEventMetadata, id: string, aggregateId: string, timestamp: number, props: P);
}
export type AnyDomainEvent = DomainEventBase<any>;
export type GetDomainEventProps<T extends AnyDomainEvent> = T extends DomainEventBase<infer P> ? P : never;
export type DomainEventBaseConstructorParamsWithProps<Props> = ConstructorParameters<typeof DomainEventBase<Props>>;
export type DomainEventBaseConstructorParams<T extends AnyDomainEvent> = DomainEventBaseConstructorParamsWithProps<GetDomainEventProps<T>>;
