export type EnumerationValue = string | number;
export declare class EnumerationBase<Value extends EnumerationValue> {
    private readonly _type;
    private readonly _value;
    constructor(type: string, value: Value);
    get type(): string;
    get value(): Value;
}
export type AnyEnumeration = EnumerationBase<EnumerationValue>;
export type GetEnumerationValue<T extends AnyEnumeration> = T extends EnumerationBase<infer V> ? V : never;
export type EnumerationBaseConstructorParamsWithValue<Value extends EnumerationValue> = ConstructorParameters<typeof EnumerationBase<Value>>;
export type EnumerationBaseConstructorParams<T extends AnyEnumeration> = EnumerationBaseConstructorParamsWithValue<GetEnumerationValue<T>>;
